package robotlegstest
{
	import robotlegs.bender.extensions.matching.TypeMatcher;
	import robotlegs.bender.extensions.mediatorMap.api.IMediatorMap;
	import robotlegs.bender.framework.api.IConfig;

	import robotlegstest.view.BaseMediator;
	import robotlegstest.view.BaseItem;
	import robotlegstest.view.Button2;
	import robotlegstest.view.MainPage;
	import robotlegstest.view.Page2;

	public class Config implements IConfig
	{
		[Inject] public var mediatorMap:IMediatorMap;

		public function configure():void
		{
			// In RobotLegs 1.5.2 I would have used this mapping for every element
//			mediatorMap.mapView(MainPage, BaseMediator, BaseItem);
//			mediatorMap.mapView(Button2, BaseMediator, BaseItem);
//			mediatorMap.mapView(Page2, BaseMediator, BaseItem);
			// ...

			// But this doesn't work anymore. I tried the follow 3 cases but none worked so far

			// #1
			// Throws
			// PropertyInjectionPoint: Injector is missing a mapping to handle injection into property "view" of object "[object BaseMediator]" with type "robotlegstest.view::BaseMediator". Target dependency: "robotlegstest.view::BaseItem|"
			mediatorMap.map(MainPage).toMediator(BaseMediator);


			// #2
			// Throws
			// VigilanceExtension: Injector mapping override for type [class BaseItem] with name (sic!)
//			mediatorMap.mapMatcher(new TypeMatcher().allOf(MainPage, BaseItem)).toMediator(BaseMediator);
//			mediatorMap.mapMatcher(new TypeMatcher().allOf(Button2, BaseItem)).toMediator(BaseMediator);


			// #3
			// Throws
			// VigilanceExtension: Injector mapping override for type [class BaseItem] with name (sic!)
//			mediatorMap.map(BaseItem).toMediator(BaseMediator);

		}
	}
}